Program STMRDemo;
{
  STMRDEMO v0.1.1 - (C)1996-98 Eddy L O Jansson / DFR Research & Engineering

 Desc:

  This is a small demonstration of some of the STMR_LOW & MID routines.
  It's in no way a complete tour of the available routines.

 Notes:

  This program will demo screen-modes 3 (80x25 and 80x50), $55 (132x25)
  and $54 (132x43). The last two modes may not be available on your
  graphics-card.
}

Uses STMR_LOW,STMR_MID;

VAR
 b              :Byte;
 OldScreen      :Pointer;
 OldScreenMode  :Byte;

 x1,y1          :Byte;

Function ReadKey: Byte; inline($B4/$08/$CD/$21);

Function KeyPressed: Boolean;
begin
 KeyPressed:=MemW[$0040:$001A]<>MemW[$0040:$001C];
end;

Function St(const I :LongInt): String;
var
 s:      String[10];
begin
 Str(I,S);
 St:=S;
end;

Procedure TLine(X1,Y1,X2,Y2 :Integer;const Color :Byte);
{ Bresenham's Line Written for the PC-GPE by Mark Feldman }
var
 i,DeltaX,DeltaY,
 numpixels,d,
 dinc1,dinc2,
 x,xinc1,xinc2,
 y,yinc1,yinc2   :Integer;
begin
  DeltaX:=Abs(x2-x1);
  DeltaY:=Abs(y2-y1);
  { Initialize all vars based on which is the independent variable }
  if DeltaX>=DeltaY then
    begin { x is independent variable }
      numpixels:=DeltaX+1;
      d:=(2*DeltaY)-DeltaX;
      dinc1:=DeltaY shl 1;
      dinc2:=(DeltaY-DeltaX) shl 1;
      xinc1:=1; xinc2:=1;
      yinc1:=0; yinc2:=1;
    end else begin { y is independent variable }
      numpixels:=DeltaY+1;
      d:=(2*DeltaX)-DeltaY;
      dinc1:=DeltaX shl 1;
      dinc2:=(DeltaX-DeltaY) shl 1;
      xinc1:=0; xinc2:=1;
      yinc1:=1; yinc2:=1;
    end;
  { Make sure x and y move in the right directions }
  if x1>x2 then begin xinc1:=-xinc1; xinc2:=-xinc2; end;
  if y1>y2 then begin yinc1:=-yinc1; yinc2:=-yinc2; end;
  { Start drawing at <x1, y1> }
  x:=x1; y:=y1;
  { Draw the pixels }
  for i:=1 to numpixels do
    begin
      SetCharXY(x,y,color);
      if d<0 then
        begin Inc(d,dinc1); Inc(x,xinc1); Inc(y,yinc1); end
         else begin Inc(d,dinc2); Inc(x,xinc2); Inc(y,yinc2); end;
    end;
end;

Procedure RotDemo;
{ Original rotation-code by Mats Magnusson (@plea.se) }
var
 SIN             :Array[0..255] of Integer;
 pos,posa,
 x1,x2,x3,
 x4,y1,y2,
 y3,y4,
 WW,HH           :Byte;
 Scr             :Pointer;

begin
 { Create sinus table }
 for Pos:=0 to 255 do SIN[Pos]:=Round(system.Sin(Pos*pi/128)*128)+128;
 WW:=(SW div 2)-2;
 HH:=(SH div 2)-2;

 { Save background }
 GetMem(Scr,PageSize);
 Move32(Mem[$B800:0000],Scr^,PageSize);

 { Rotation loop }
 PosA:=0;
 Repeat
  { Calculate the corners of the polygon }
  Inc(PosA);
  pos:=posa;
  x1:=((SW div 2)+Round(system.Sin(pos*pi/128)*128*WW) div 128);
  y1:=((SH div 2)+(SIN[Byte((pos+64))]*HH) div 128-HH);
  Inc(Pos,64);
  x2:=((SW div 2)+Round(system.Sin(pos*pi/128)*128*WW) div 128);
  y2:=((SH div 2)+(SIN[Byte((pos+64))]*HH) div 128-HH);
  Inc(Pos,64);
  x3:=((SW div 2)+Round(system.Sin(pos*pi/128)*128*WW) div 128);
  y3:=((SH div 2)+(SIN[Byte((pos+64))]*HH) div 128-HH);
  Inc(Pos,64);
  x4:=((SW div 2)+Round(system.Sin(pos*pi/128)*128*WW) div 128);
  y4:=((SH div 2)+(SIN[Byte((pos+64))]*HH) div 128-HH);
  { Restore original background }
  WaitVBL;
  Move32(Scr^,Mem[$B800:0000],PageSize);
  { Draw the polygon }
  TLine(x1,y1,x2,y2,Ord('*'));
  TLine(x2,y2,x3,y3,Ord('*'));
  TLine(x3,y3,x4,y4,Ord('*'));
  TLine(x4,y4,x1,y1,Ord('*'));
{  SetColor(0,0,0,0);}
 until KeyPressed;
 { remove key from buffer }
 b:=ReadKey;
 { free used memory }
 FreeMem(Scr,PageSize);
end;

Procedure doDEMO;
{ This procedure demonstrates the basic Lowlevel routines }
var
 Loop           :Word;
 B,XX,YY        :Byte;
 P              :Pointer;
begin
 STMR_LOW.Init;
 { Set gray screen }
 FillScreen((120 shl 8)+32);

 { Write to all corners }
 WriteXY(0,0,'UPPER LEFT CORNER');
 WriteXY(SW-18,0,'UPPER RIGHT CORNER');
 WriteXY(SW-18,SH-1,'LOWER RIGHT CORNER');
 WriteXY(0,SH-1,'LOWER LEFT CORNER');

 { Write with color in all corners }
 WriteXYC(0,0,27,'UPPER LEFT CORNER');
 WriteXYC(SW-18,0,63,'UPPER RIGHT CORNER');
 WriteXYC(0,SH-1,93,'LOWER LEFT CORNER');
 WriteXYC(SW-18,SH-1,142,'LOWER RIGHT CORNER');

 { Draw some centered text. }
 Centre ('This is centered at line 10',10);
 CentreC('This too is centered.. and using color',11,58);
 CentreCode(#126#10' Screen Dimensions~'#2': ~'#15+St(SW)+#126#2'x'#126#15
           +St(SH)+#126#2' (~'#15+St(PageSize)+#126#2') ',0);

 { Draw three boxes; 'Gray', Blue and Green. }
 BoxChar(10,13,SW-20,5,64);
 BoxAttr(10+2,13+2,SW-20,5,27);
 BoxCharAttr(10+4,13+4,SW-20,5,Word(42 SHL 8)+Ord('A'));

 { Draw some HORIZONTAL lines }
 DrawHChar(5,5,SW-10,Ord(''));
 DrawHAttr(5,6,SW-10,94);
 DrawHCharAttr(5,7,SW-10,$08C4);

 { Draw some VERTICAL lines }
 DrawVChar(5,8,SH-10,Ord(''));
 DrawVAttr(6,8,SH-10,94);
 DrawVCharAttr(7,8,SH-10,$08B3);

 WriteXYCode(0,3,'~?WriteXYCode: ~'+#$1B+'Norton~Novell~qRemote Access');

 WindowBox2(10,SH-14,50,10,127,120,126,SinFrame,0,62,'WindowBox2()',True);
 WindowBox(11,SH-13,48,8,120,127,126,SinFrame,False);
 WriteXY(13,SH-10,'Normal WindowBox() (no header, no shadow)');
end;

Procedure DoDemos;
begin
{ 40x25  } SetScreen(1);  doDemo; RotDemo;
{ 80x25  } SetScreen(3);  doDemo; RotDemo;
{ 80x50  } Font_Set8x8;    doDemo; RotDemo;

 { *NOTE* These are graphics-card specific! Use a program like 'SCANMODE'
   (bundled with Terminate\utils) to find available text-modes }

{ 132x25 } SetScreen($55);  doDemo; RotDemo;
{ 132x43 } SetScreen($54);  doDemo; RotDemo;
end;

BEGIN
 STMR_LOW.Init; { <-- important! }

 { Save screenmode + content }
 OldScreenMode:=PreviousVideoMode;
 ScreenStore(OldScreen);

 HideCursor;
 SetBlink(False);
 FillScreen((144 shl 8)+32);
 AttentionWindow((SW div 2)-35,5,70,3,30,144);
 CentreCode('~Welcome to this ~DEMONSTRATION~ of ~'#25'Sarumans ~'#26'Text ~'#27'Mode ~'#28'Routines',6);
 AttentionWindow((SW div 2)-(51 div 2)-1,SH-2,51,1,207,144);
 CentreCode('~PRESS ~ENTER~ TO CONTINUE TO THE NEXT SCREEN!',SH-2);
 b:=Ord(ReadKey);
 DoDemos;

 { Try to restore old screenmode and content }
 SetScreen(OldScreenMode);
 ScreenRestore(OldScreen);
END.
