Program TInputDemo;
{
  YA-QGIR v0.2.2 - (C)1996,98 Eddy L O Jansson / DFR Research & Engineering

 Description:

  Yet another quite general input routine. After using my old version for
  many years it was time to rewrite it from the ground up. This is the result.
  The major difference is the 'edit-window' support. You can edit string
  up to 255 characters in a 'window' of any size. The code is quite clean,
  so you should have no problems adding or removing features.

 Usage:

  Instead of passing lot's of parameters you pass a record. If you rather
  pass parameters you can easily encapsule the TInput() routine.

  Setup a TInputRec record. Call TInput() with that records variable. Done.

 Future:

  Create Object'ized version.

 Notes:

  This demonstration and TInput() itself uses some routines from my
  my STMR_LOW and STMR_MID units. If you don't have these, search the
  SWAG or simply rewrite the needed functions yourself.

 History

 v0.2.1  98-01-29  Fixed StartPos bug.
 v0.2.2  98-06-23  Fixed no overwrite when string full bug.
                   End-of-buf are now handled in a prettier way

 Copyright:

  This is FREEWARE. Use it, modify it, spread it. If you want you can send
  me a 'thank you' e-mail, or maybe a free copy of whatever you've made.

              E-mail: srm_dfr@hotmail.com    FidoNET: 2:206/233
}
Uses STMR_LOW,STMR_MID,STMR_HI,STMR_STR,ASMUtils;

{
  Relevant code is found in STMR_HI as "TInput()" and "TInputRec"
}

VAR
 I           :TInputRec;
 XX,YY       :Byte;

{---------------------------------------------------------------------------}

{ A simple demonstration }
BEGIN
 STMR_LOW.Init;
 ClrScr;

 XX:=10;
 YY:=5;

 WindowBox2(XX,YY,60,5,127,112,127,SinFrame,0,62,' TInput() Example ',True);
 WriteXYC(XX+3,YY+2,112,'Please enter something:');

 With I do begin
  X:=XX+27;
  Y:=YY+2;
  StartS:='right here';
{  StartS:='01234567890123456789';}
  S:='';
  Width:=20;
  MaxLen:=25; {SizeOf(S)-1;}
  StartPos:=Length(StartS);
  BackChar:='';
  Insert:=True;
  Arrows:=True;
  AcceptSet  :=[#32..#254];
  NormExitSet:=[#27,#13];
  ExtExitSet :=[#72,#80];
 end;

 { Setup arrow colors. Note: Arrows are placed -outside- the edit window. }
 SetAttrXY(I.X-1,I.Y,113);
 SetAttrXY(I.X+I.Width,I.Y,113);

 { Do the input }
 TInput(I);
 WriteXYCode(0,12,'~'#15'You Entered ~'#7'"~'#27+I.S+'~'#7'"');
 GotoXY(0,SH-2);
END.

{
 Example of encapsule'ing:

 Ut:=TInputA(1,1,'Hej igen!',8,16,I.Status));

Function TInputA(const X,Y: Byte;const StartS: String;const Width,MaxLen: Byte;
                 var InputStatus: Word): String;
var
 I              :TInputRec;
begin
 I.X:=X;
 I.Y:=Y;
 I.StartS:=StartS;
 I.Width:=Width;
 I.MaxLen:=MaxLen;
 With I do begin
  S:='';
  StartPos:=Length(StartS);
  BackChar:='';
  Insert:=True;
  Arrows:=True;
  AcceptSet  :=[#32..#255];
  NormExitSet:=[#27,#13];
  ExtExitSet :=[#72,#80];
 end;
 TInput(I);
 TInputA:=I.S;
end;
}
