Unit STMR_FON; { Sarumans Text Mode Routines (EGA/VGA Fonts) }

{
 STMR_FON v0.1.1 - (C)1997-98 Eddy L O Jansson / DFR Research & Engineering

 Description:


 Usage:

 Notes:

 Future:

 History:

  0.1.1  Added 2 banks/512 chars support.
  0.1.0  Inhouse use only. (begun in 97-06-12)

}

INTERFACE

CONST
 TSTMRfont_ID   :Array[1..5] of Char=('S','F','o','n','t');

TYPE
 PathStr = String[79];

 TSTMRfont = Record
  Version       :Byte;       { This structure is version $01 }
  Description   :String[40];
  Author        :String[32];
  BPC           :Byte;
  Chars         :Word;
  FirstChar     :Word;
  data          :Pointer;    { not part of the header when written to file }
 end;

 {
  Note: Header versions $00 thru $10 are reserved by me. Please respect
        this. Version $02 will have a bitmap describing which characters
        to change. Version $00 will be a simpler format, with only the
        version + fontdata.
 }

{-[ Function Interface ]----------------------------------------------------}

Procedure Font_Install(const Font: TSTMRfont;const bank: Byte);
Procedure Font_Define(const CharNr,BytesPerCharacter: Byte;VAR data);
Procedure Font_Fetch(var Font: TSTMRFont);
Procedure Font_FetchChar(const CharNr: Word;var Font);
Procedure Font_FetchROM(var Font :TSTMRfont);
Function  Font_GetCurrentBPC: Word;

Procedure Font_Enable512Chars;

Function  Font_Load(const Filename: PathStr;VAR Font: TSTMRfont): Boolean;
Function  Font_LoadExec(const Filename: PathStr;const Bank: Byte): Boolean;
Procedure Font_Save(const Filename: PathStr;Font: TSTMRfont);
Procedure Font_DumpInfo(const Font: TSTMRfont);

Procedure Font_Set8x8ROMddFont(const bank: Byte);
Procedure Font_Set8x8ROMddFont2(const bank: Byte);
Procedure Font_Set8x14ROMmoFont(const bank: Byte);
Procedure Font_Set8x14ROMmoFont2(const bank: Byte);
Procedure Font_Set8x16ROMFont(const bank: Byte);
Procedure Font_Set8x16ROMddFont(const bank: Byte);

{-[ Implementation / Code ]-------------------------------------------------}

IMPLEMENTATION

Procedure Font_Install(const Font: TSTMRfont;const bank: Byte); Assembler;
asm
 les  di,Font
 mov  ax,$1110
 mov  bl,bank  { block 0 or 6 usually used by stmr_fon }
 mov  bh,byte ptr es:[di+TSTMRfont.BPC]
 mov  cx,word ptr es:[di+TSTMRfont.CHARS]
 mov  dx,word ptr es:[di+TSTMRfont.FIRSTCHAR]
 push bp
 les  bp,es:[di+TSTMRfont.data]
 int  $10
 pop  bp
end;

Procedure Font_Define(const CharNr,BytesPerCharacter: Byte;VAR data); Assembler;
asm
 mov  ax,$1110
 mov  bl,0   { block 0 }
 mov  bh,BytesPerCharacter;
 mov  cx,1
 xor  dh,dh
 mov  dl,CharNr
 push bp
 les  bp,data
 int  $10
 pop  bp
end;

Procedure Font_Fetch(var Font: TSTMRFont); Assembler;
asm
 cli
 mov  dx,$3C4
 mov  ax,$0402
 out  dx,ax
 mov  ax,$0704
 out  dx,ax
 mov  dx,$3CE
 mov  ax,$0204
 out  dx,ax
 mov  ax,$0005
 out  dx,ax
 mov  ax,$0006
 out  dx,ax
 sti
 push ds
 les  di,Font
 mov  ax,$A000
 mov  ds,ax
 mov  si,word ptr es:[di+TSTMRFont.FIRSTCHAR]
 shl  si,5
 mov  dx,word ptr es:[di+TSTMRFont.CHARS]
 xor  ch,ch
 mov  cl,byte ptr es:[di+TSTMRFont.BPC]
 mov  bx,cx
 mov  ax,32
 sub  ax,bx
 shr  bx,1
 les  di,es:[di+TSTMRFont.data]
@nextchar:
 mov  cx,bx
 rep  movsw
 add  si,ax
 dec  dx
 jnz  @nextchar
 pop  ds
 cli
 mov  dx,$3C4
 mov  ax,$0302
 out  dx,ax
 mov  ax,$0304
 out  dx,ax
 mov  dx,$3CE
 mov  ax,$0004
 out  dx,ax
 mov  ax,$1005
 out  dx,ax
 mov  ax,$0E06
 out  dx,ax
 sti
end;

Procedure Font_FetchChar(const CharNr: Word;var Font); Assembler;
asm
 cli
 mov  dx,$3C4
 mov  ax,$0402
 out  dx,ax
 mov  ax,$0704
 out  dx,ax
 mov  dx,$3CE
 mov  ax,$0204
 out  dx,ax
 mov  ax,$0005
 out  dx,ax
 mov  ax,$0006
 out  dx,ax
 sti
 push bp
 mov  ax,$1130
 mov  bh,2
 int  $10         { Get BPC into CX }
 pop  bp
 push ds
 les  di,Font
 mov  ax,$A000
 mov  ds,ax
 mov  si,CharNr
 shl  si,5
 mov  dx,1
 { cx = BPC }
 mov  bx,cx
 mov  ax,32
 sub  ax,bx
 shr  bx,1
 les  di,font
 mov  cx,bx
 rep  movsw
 pop  ds
 cli
 mov  dx,$3C4
 mov  ax,$0302
 out  dx,ax
 mov  ax,$0304
 out  dx,ax
 mov  dx,$3CE
 mov  ax,$0004
 out  dx,ax
 mov  ax,$1005
 out  dx,ax
 mov  ax,$0E06
 out  dx,ax
 sti
end;

Procedure Font_FetchROM(var Font :TSTMRfont); Assembler;
asm
 mov ax,$1130;
 mov bh,6
{ 0 INT 1F pointer, 1 INT 44h pointer, 2 ROM 8x14 pointer
  3 ROM 8x8 double dot pointer (base), 4 ROM 8x8 double dot pointer (top)
  5 ROM 9x14 alpha alternate pointer,  6 ROM 8x16 character table pointer
  7 ROM 9x16 alternate character table pointer }
 push bp
 int  $10
 mov  ax,bp
 mov  bx,es
 pop  bp
 les  di,Font
 mov  word ptr es:[di+TSTMRfont.BPC],16
 mov  word ptr es:[di+TSTMRfont.CHARS],256
 mov  word ptr es:[di+TSTMRfont.FIRSTCHAR],0
 mov  word ptr es:[di+TSTMRfont.data],ax
 mov  word ptr es:[di+TSTMRfont.data+2],bx
end;

Function Font_GetCurrentBPC: Word; Assembler;
asm
 push bp
 mov  ax,$1130
 mov  bh,2
 int  $10
 mov  ax,cx
 pop  bp
{ DL = rows (less 1)
  ES:BP = pointer to table (fontdatas) }
end;

Procedure Font_Enable512Chars; Assembler;
{
 Enables use of 2*256 chars at the same time. Bit 3 of the attribute
 (=intensity) chooses bank to display. This sets up bank 0 for non-intens
 and bank 6 for intensity.
}
Asm
  mov  ah,$11;
  mov  al,3
  mov  bl,40;
               { 128   64   32   16  |  8   4   2   1              banks
                                 X   |          X         = 18    (0 - 6)
                            X        |  X                 = 40    (6 - 0) }
  int     $10;
End;

Function Font_Load(const Filename: PathStr;VAR Font: TSTMRfont): Boolean;
var
 ID             :Array[1..5] of Char;
 F              :File;
 Dummy          :Word;
 label          exitError;
begin
 Font_Load:=False;
 Assign(F,Filename);
 Reset(F,1);
 { Check if correct ID }
 BlockRead(F,ID,SizeOf(ID),Dummy);
 if NOT (ID=TSTMRfont_ID) then goto exitError;
 { Check if known version }
 BlockRead(F,Font.version,1,Dummy);
 if Font.version<>1 then goto exitError;
 { File passed the tests. Let's load it. }
 BlockRead(F,Font.Description,SizeOf(TSTMRfont)-SizeOf(Font.data)-SizeOf(Font.version),Dummy);
 GetMem(font.data,Font.BPC*Font.CHARS);
 BlockRead(F,font.data^,Font.BPC*Font.CHARS,Dummy);
 Close(F);
 Font_Load:=True;
exitError:
end;

Function Font_LoadExec(const Filename: PathStr;const Bank: Byte): Boolean;
var
 TmpFont        :TSTMRfont;
begin
 if Font_Load(Filename,TmpFont) then
  begin
   Font_DumpInfo(TmpFont);
   Font_Install(TmpFont,Bank);
   FreeMem(TmpFont.Data,TmpFont.BPC*TmpFont.CHARS);
  end else Font_LoadExec:=False;
end;

Procedure Font_Save(const Filename: PathStr;Font: TSTMRfont);
var
 F              :File;
 Dummy          :Word;
begin
 Assign(F,Filename);
 ReWrite(F,1);
 { Write ID }
 BlockWrite(F,TSTMRfont_ID,SizeOf(TSTMRfont_ID),Dummy);
 { Write header }
 BlockWrite(F,Font,SizeOf(TSTMRfont)-SizeOf(Font.data),Dummy);
 { Write bitmap }
 BlockWrite(F,Font.data^,Font.BPC*Font.CHARS,Dummy);
 Close(F);
end;

Procedure Font_DumpInfo(const Font: TSTMRfont);
begin
 WriteLn('Description: ',Font.Description);
 WriteLn('Author: ',Font.Author);
 WriteLn('Bytes/Char: ',Font.BPC);
 WriteLn('Chars Defined: ',Font.CHARS);
 WriteLn('1st Char Defined: ',Font.FIRSTCHAR);
 WriteLn('Bitmapsize: ',Font.BPC*Font.CHARS);
 WriteLn('Font Header Version: ',Font.Version);
end;

Procedure Font_Set8x14ROMmoFont(const bank: Byte); Assembler;
asm
 mov ax,$1101
 mov bl,bank
 int $10
end;

Procedure Font_Set8x8ROMddFont(const bank: Byte); Assembler;
asm
 mov ax,$1102
 mov bl,bank
 int $10
end;

Procedure Font_Set8x16ROMFont(const bank: Byte); Assembler;
asm
 mov ax,$1104
 mov bl,bank
 int $10
end;

Procedure Font_Set8x14ROMmoFont2(const bank: Byte); Assembler;
asm
 mov ax,$1111
 mov bl,bank
 int $10
end;

Procedure Font_Set8x8ROMddFont2(const bank: Byte); Assembler;
asm
 mov ax,$1112
 mov bl,bank
 int $10
end;

Procedure Font_Set8x16ROMddFont(const bank: Byte); Assembler;
asm
 mov ax,$1114
 mov bl,bank
 int $10
end;

END.
