Unit STMR_HI; { Sarumans Text Mode Routines (Hi-level) }
{
 STMR_HI v0.0.1 - (C)1998 Eddy L O Jansson / DFR Research & Engineering

  Various "hi-level" routines to manipulate textmodes.

    ** This isn't a finished library, I'm still building on this. **

 Shortcommings:

 Copyright:

  This is FREEWARE. Use it, modify it, spread it. If you want you can send
  me a 'thank you' e-mail, or maybe a free copy of whatever you've made.

           E-mail: srm_dfr@hotmail.com     FidoNET: 2:206/233
}
INTERFACE
Uses STMR_LOW,STMR_MID,STMR_STR,ASMUtils;

TYPE

 CharSet          = Set of Char;
 PByteParam       = Procedure(const B: Byte);

 OScrollBar = object
 Constructor    Init(const XX,YY,LL,VP: Byte;
                     const BackAC,BarAC: Word;
                     const TotalEntries: LongInt);
 Procedure      ReSize(const XX,YY,LL: Byte;const Entry: LongInt);
 Procedure      Update(const Entry: LongInt);
 Destructor     Done;
 private
  X,Y,L,ViewP    :Byte;
  BarAttrChar,
  BackAttrChar   :Word;
  Entries        :LongInt;
  SavedBack      :Pointer;
 end;

 TInputRec = Record { 267 bytes. Increase string length as needed. }
  X,Y         :Byte;         { Position of input }
  S           :String;       { Outstring (result) }
  StartS      :String;       { Default string }
  Width       :Byte;         { Width of edit-window }
  MaxLen      :Byte;         { Maximum string-length allowed to be input }
  StartPos    :Byte;         { Where to start edit. -1 = end of string }
  BackChar    :Char;         { Background character. #176 is nice. }
  Arrows,                    { Use 'direction' arrows? }
  Insert      :Boolean;      { Insert or Overwrite? }
  AcceptSet   :Set of Char;  { Standard keys accepted as input }
  NormExitSet :Set of Char;  { Standard keys to exit on }
  ExtExitSet  :Set of Char;  { Extended keys to exit on }
  Status      :Word;         { Returns the key used to terminate the routine }
                             { If extended key then status = $00xx else $xx00 }
 end;

{-[ Function Interface ]----------------------------------------------------}

Function Input(X,Y: Byte;StartStr: String;BackG: Char;MaxLen,StartPos:
               Integer;AcceptSet: CharSet;Ins: Boolean;var InputStatus: Byte): String;

Procedure TInput(var TI: TInputRec);

Function InputSBox(const XX,YY,MaxL: Byte;Title: String): String;

Function ChooseAttr(const X,Y,DefaultAttr: Byte;var ATTR: Byte;
                    UpdateProc: PByteParam): Boolean;
{
  Written: 96-12-15, Eddy L O Jansson (2:206/233)

  Description: Small function to easily choose an attribute. A perfect
  tool for your toolbox and easily adapted to fit into your programs.
}

{-[ Implementation / Code ]-------------------------------------------------}

IMPLEMENTATION

Function Input(X,Y: Byte;StartStr: String;BackG: Char;MaxLen,StartPos:
               Integer;AcceptSet: CharSet;Ins: Boolean;var InputStatus: Byte): String;
{Version 1.5}
Var
P:      Byte;
Exit:   Boolean;
ch:     Char;
ext:    Char;
s:      String;
t:      String[1];

Function ReadKey: Char; inline($B4/$08/$CD/$21);

begin
Exit:=False;                                      { Don't quit on me yet! }
if BackG='' then BackG:=' ';
if Length(StartStr)>MaxLen then Left(StartStr,MaxLen);
if StartPos>Length(StartStr) then StartPos:=Length(StartStr);
if StartPos=-1 then StartPos:=Length(StartStr);
If StartPos>=MaxLen then StartPos:=MaxLen-1;

s:=StartStr;                                { Put StartStr into Edit Buffer }
WriteXY(X,Y,RepeatChar(BackG,MaxLen));

if StartStr<>'' then WriteXY(X,Y,StartStr);

p:=StartPos;
GotoXY(X+StartPos,Y);

repeat
 if Ins then NormalCursor else BlockCursor;
 ext:=#0;
 ch:=ReadKey;
 if ch=#0 then ext:=ReadKey;
 if ch=#27 then begin
                 InputStatus:=27;
                 Exit:=True;
                end;
{   (ch<#255) and (ch>#31) }
if ch in AcceptSet then
  begin   { Welcome to the jungle...}
   t:=ch;
    if (p=length(s)) and (Length(s)<MaxLen) then
     begin
      s:=s+t;
      WriteXY(X+P,Y,T);
      Inc(p);
     end else
      if length(s)<MaxLen then
       begin
        if Ins then Insert(T,S,P+1) else s[p+1]:=Ch;
        WriteXY(X+P,Y,Copy(S,P+1,Length(S)));
        Inc(p);
       end else if (Length(s)=MaxLen) and (not Ins) then
         begin
          s[p+1]:=ch;
          WriteXY(X+P,Y,T);
          Inc(p);
         end;
      ch:=#0;
      if p>MaxLen-1 then p:=MaxLen-1;
      GotoXY(X+P,Y);
     end else
begin
 case ch of { CTRL-Y }
  #25:   begin
          WriteXY(X,Y,RepeatChar(BackG,Length(S)));
          P:=0;
          S:='';
          GotoXY(X,Y);
         end;
 {Backspace}
 #8: If (P>0) then
  begin
   if (p+1=MaxLen) and (p<length(s)) then Ext:=#83 else
    begin
     Delete(S,P,1);
     Dec(P);
     GotoXY(X+P,Y);
     WriteXY(X+P,Y,Copy(S,P+1,Length(s))+BackG)
    end;
  end;

  #9: begin { Exit on TAB }
       InputStatus:=9;
       Exit:=True;
      end;

 #13: begin
       InputStatus:=13;
       Exit:=True;
      end;
 end; { Case CH of }

 case ext of
 #75: if P>0 then begin
 {Left Arrow}      Dec(P);
                   GotoXY(X+P,Y);
                  end;

 #77: if (P<Length(s)) and (P+1<MaxLen) then begin
 {Right Arrow}             Inc(P);
                           GotoXY(X+P,Y);
                          end;

 #82: Ins:=Not(Ins); {Insert}
 {Delete}
 #83: If P<Length(s) then begin
                           Delete(S,P+1,1);
                           WriteXY(X+P,Y,Copy(S,P+1,Length(s))+BackG);
                          end;

 #71: begin
       p:=0;
       GotoXY(X+P,Y);
      end;

 #79: begin
       p:=Length(s);
       if p>=MaxLen then P:=MaxLen-1;
       GotoXY(X+P,Y);
      end;

 #72,#73,#80,#81,#59..#68:
  begin
   InputStatus:=Ord(Ext);
   Exit:=True;
  end;

 end; {Case of EXT }
end; { if not normal char }

until Exit;
Input:=S;
end;

Procedure TInput(var TI: TInputRec);
{ This is the /static/ version. Consider a 'UpdateIfKeypressed' version }
var
 Done           :Boolean; { Exit routine if TRUE }
 P              :Byte;    { Pointer into the string }
 LP             :Byte;    { Pointer into pos of string in leftmost pos of window }
 Ch,ChE         :Char;
 VP             :Integer; { Cursorpos in window (0 to TI.Width-1 }
 S,SS           :String;  { local temp-variables }

 Procedure UpdateWindow;
 begin
  SS:=Copy(S,LP,TI.Width); { Original: Copy_P(S,LP,TI.Width,SS); }
  PadRight_P(SS,Ti.Width,Ord(TI.BackChar));
  WriteXY(TI.X,TI.Y,SS);
  if TI.Arrows then begin
   if LP>1 then WriteXY(TI.X-1,TI.Y,#17) else WriteXY(TI.X-1,TI.Y,#32);
   if Length(S)>=LP+TI.Width then WriteXY(TI.X+TI.Width,TI.Y,#16) else WriteXY(TI.X+TI.Width,TI.Y,#32);
  end;
  GotoXY(TI.X+VP,TI.Y);
 end;

 Procedure MoveCursLeft;
 begin
  Dec(P); Dec(VP);
  if VP<0 then begin Dec(LP); VP:=0; end;
  UpdateWindow;
 end; { LeftKey }

 Procedure MoveCursRight;
 begin
  if P{+1}<TI.MaxLen then  { 9806: Better end-of-buf handling }
   begin
    Inc(P); Inc(VP);
    if VP>TI.Width-1 then begin Inc(LP); VP:=TI.Width-1; end;
   end;
  UpdateWindow;
 end; { RightKey }

 Procedure doExtendedKey;
 begin
  ChE:=ReadKey; { Read Extended Key }

  if NOT (ChE in TI.ExtExitSet) then begin

  { Leftkey }
  if (ChE=#75) AND (P>0) then MoveCursLeft;
  { Rightkey }
  if (ChE=#77) AND (P<Length(S)) then MoveCursRight;
  { Insert/Overwrite }
  if (ChE=#82) then
   begin
    TI.Insert:=NOT TI.Insert;
    if TI.Insert then NormalCursor else BlockCursor;
   end;
  { Home }
  if (ChE=#71) then
   begin
    P:=0; VP:=0; LP:=1;
    UpdateWindow;
   end;
  { End }
  if (ChE=#79) then
   begin
    P:=Length(S);
    VP:=MinI(P,TI.Width-1);
    LP:=MaxI(1,P-TI.Width+2);
    UpdateWindow;
   end;
  { Delete }
  if (ChE=#83) then
   begin
    Delete(S,P+1,1);
    UpdateWindow;
   end;
  end else begin Done:=True; TI.Status:=Ord(ChE); end;
 end; { doExtendedKey }

 Procedure doNormalKey;
 begin
   if (TI.Insert) then
   begin
    if (Length(S)<TI.MaxLen) then
    begin
     Insert(Ch,S,P+1);
     MoveCursRight;
    end;
   end else begin { if overwrite }
    if (P+1>Length(S)) and (Length(S)<TI.MaxLen) then S:=S+Ch else S[P+1]:=Ch;
    MoveCursRight;
   end;

 end; { doNormalKey }

begin
 { Fix background character }
 if TI.BackChar='' then TI.BackChar:=' ';
 { Don't allow entering of strings longer than supported by the structure }
 if TI.MaxLen>SizeOf(TI.S)-1 then TI.MaxLen:=SizeOf(TI.S)-1;
 { Truncate string if longer than allowed }
 if Length(TI.StartS) > TI.MaxLen then Left(TI.StartS,TI.MaxLen);
 { Fix startpos if larger than string }
 if TI.StartPos>Length(TI.StartS) then TI.StartPos:=Length(TI.StartS);
 { Setup local edition of TI.startS }
 S:=TI.StartS;
 { Write the 'entry-form' }
 WriteXY(TI.X,TI.Y,RepeatChar(TI.BackChar,TI.Width));

 { Setup a most important variable, the pointer into the string }
 P:=TI.StartPos;
 VP:=MinI(P,TI.Width-1);
 { Setup LP - The start-pos of the string in the window }
 LP:=MaxI(1,P-TI.Width+1);
 if P>=TI.Width then Inc(LP); { fixup }
 if TI.Insert then NormalCursor else BlockCursor;

 { Update the entry-window }
 UpdateWindow;
 Done:=False;
 REPEAT
  Ch:=ReadKey;
  if Ch in TI.NormExitSet then
   begin
    Done:=True;
    TI.Status:=Word(Ord(Ch) SHL 8);
   end else begin
    if Ch=#0 then doExtendedKey else
     if Ch in TI.AcceptSet then doNormalKey else
      begin { Very special keys }
       { Backspace }
       if (Ch=#8) and (P>0) then
        begin
         Delete(S,P,1);
         MoveCursLeft;
        end;
       { CTRL+Y }
       if (Ch=#25) then
        begin
         S:=''; VP:=0; P:=0; LP:=1;
         UpdateWindow;
        end;
      end; { .. was special-special key }

   end; { take care of character }
 UNTIL Done;

 { Remove arrows }
 if TI.Arrows then begin
  WriteXY(TI.X-1,TI.Y,#32);
  WriteXY(TI.X+TI.Width,TI.Y,#32);
 end;

 TI.S:=S;
end;

Function InputSBox(const XX,YY,MaxL: Byte;Title: String): String;
var
 I          :TInputRec;
 OldScreen  :Pointer;
 Wi         :Byte;
begin
{ ScreenStore(OldScreen);}
 Wi:=MinI(MaxL+4,SW-XX);
 TextBoxGet(XX,YY,Wi+4,5,OldScreen);
 WindowBox2(XX,YY,Wi+4,5,127,112,127,SinFrame,0,62,' '+Title+' ',True);
 With I do begin
  X:=XX+2;
  Y:=YY+2;
  StartS:='';
  S:='';
  Width:=Wi;
  MaxLen:=MinI(SizeOf(S)-1,MaxL);
  StartPos:=Length(StartS);
  BackChar:='';
  Insert:=True;
  Arrows:=True;
  AcceptSet:=[#32..#255];
  NormExitSet:=[#27,#13];
  ExtExitSet:=[#72,#80];
 end;
 SetAttrXY(I.X-1,I.Y,113);
 SetAttrXY(I.X+I.Width,I.Y,113);
 TInput(I);
 HideCursor;
{ ScreenRestore(OldScreen);}
 TextBoxPut(XX,YY,OldScreen);
 InputSBox:=I.S;
end;

Function ChooseAttr(const X,Y,DefaultAttr: Byte;var ATTR: Byte;UpdateProc: PByteParam): Boolean;
{
 Possible extensions:
  * Pass-thru of characters to external procedure.
}
const
 BackChar :Byte=7;
 MarkChar :Byte=8;

var
 XX,YY,OX,OY    :Byte;
 C              :Byte;
 Ch             :Char;
 OldBack        :Pointer;
 Blink,HiBack   :Boolean;

 Procedure DrawColorTable(const Blink: Boolean);
 var
  XX,YY,C         :Byte;
 begin
  C:=255;
  for YY:=Y+1 to Y+8 do
   for XX:=X+1 to X+16 do
    begin
     Inc(C);
     SetCharAttrXY(XX,YY,Word((C+(Byte(Blink) SHL 7)) SHL 8)+BackChar);
    end;
 end;

begin
 GetMem(OldBack,(16+2)*(8+2)+4);
 TextBoxGet(X,Y,16+2,8+2,OldBack);
 WindowBox(X,Y,16+2,8+2,12,4,0,SinFrame,False); { No shadows }
 C:=DefaultAttr;
 { Check/Fixup if default-attr is blinking }
 if C>127 then
  begin
   Dec(C,127);
   Blink:=True;
  end else Blink:=False;
 DrawColorTable(Blink);
 { Convert 1D Attribute into 2D Screen-coords }
 XX:=(C mod 16)+1;
 YY:=((C div 16) mod 8)+1;
 { Main loop }
 Repeat
  { Optional; Call external user procedure with attribute as parameter }
  if @UpdateProc<>nil then UpdateProc(C);

  WriteXYC(X+8,Y+9,78,HexB(C));
  SetCharXY(X+XX,Y+YY,MarkChar);
  Ch:=ReadKey;
  OX:=XX; OY:=YY;
  { Read cursor keys }
  if Ch=#0 then begin
   Ch:=ReadKey;
   if (Ch=LeftKey) and (XX>1) then Dec(XX);
   if (Ch=RightKey) and (XX<16) then Inc(XX);
   if (Ch=UpKey) and (YY>1) then Dec(YY);
   if (Ch=DownKey) and (YY<8) then Inc(YY);
  end else begin
   { Toggle High-intensity background colors On/Off }
   if (Ch='H') or (Ch='h') then
    begin
     HiBack:=NOT HiBack;
     SetBlink(HiBack);
    end;
   { Toggle Blink On/Off }
   if (Ch='B') or (Ch='b') then
    begin
     Blink:=NOT Blink;
     DrawColorTable(Blink);
    end;
   end;
  { If choose new attribute then ... }
  if (OX<>XX) or (OY<>YY) then SetCharXY(X+OX,Y+OY,BackChar);
  { Calculate 1D Attribute from 2D coordinates }
  C:=(XX+((YY-1)*16)-1)+(Byte(Blink) SHL 7);
 Until (Ch=ESC) or (Ch=ENTER); { Main loop }
 TextBoxPut(X,Y,OldBack);
 FreeMem(OldBack,(16+2)*(8+2)+4);
 if Ch=ENTER then
  begin
   Attr:=C;
   ChooseAttr:=True;
  end else ChooseAttr:=False;
end;

Constructor OScrollBar.Init(const XX,YY,LL,VP: Byte;
                            const BackAC,BarAC: Word;
                            const TotalEntries: LongInt);
begin
 X:=XX;
 Y:=YY;
 L:=LL;
 ViewP:=VP;
 BarAttrChar:=BarAC;
 BackAttrChar:=BackAC;
 Entries:=TotalEntries;
 GetMem(SavedBack,4+(L*2));
 TextBoxGet(X,Y,1,L,SavedBack);
end;

Procedure   OScrollBar.ReSize(const XX,YY,LL: Byte;const Entry: LongInt);
begin
 { Release mem }
 Done;
 { Reconfigure }
 X:=XX;
 Y:=YY;
 L:=LL;
 { Save background }
 GetMem(SavedBack,4+(L*2));
 TextBoxGet(X,Y,1,L,SavedBack);
 { Update screen }
 Update(Entry);
end;

Procedure   OScrollBar.Update(const Entry: LongInt);
{
 Demonstration:
   New(Bar,Init(40,2,22,20,($78 shl 8+$B1),($7F shl 8+$DB),50));
   Bar^.Update(20);
   Dispose(Bar,Done);
}
var
 L1,L2,P1,P2      :Byte;
begin
 if Entries>ViewP then
 begin
  P1:=Trunc((ViewP/Entries)*100);
  if P1=0 then P1:=1;
  L1:=Trunc(L/(100/P1));               { Length of slider }
  if L1=0 then L1:=1;
  P2:=Trunc((Entry/Entries)*100);
  if P2=0 then P2:=1;
  L2:=Trunc((L-L1)/(100/P2));          { Offset of slider }
 end else begin
  L2:=0;
  L1:=L;
 end;
 DrawVCharAttr(X,Y,L,BackAttrChar);
 DrawVCharAttr(X,Y+L2,L1,BarAttrChar);
end;

Destructor   OScrollBar.Done;
begin
 TextBoxPut(X,Y,SavedBack);
 FreeMem(SavedBack,4+(L*2));
end;




BEGIN
 { Setup/Initialization }
END.
