Unit STMR_MID; { Sarumans Text Mode Routines (Mid-level) }
{
 STMR_MID v0.0.2 - (C)1996-98 Eddy L O Jansson / DFR Research & Engineering

  Various "mid-level" routines to manipulate textmodes. Supports extended
  (SVGA) textmodes (132*43, 132*25, etc).

    ** This isn't a finished library, I'm still building on this. **

 Shortcommings:

  No explicit monochrome support.

 Copyright:

  This is FREEWARE. Use it, modify it, spread it. If you want you can send
  me a 'thank you' e-mail, or maybe a free copy of whatever you've made.

           E-mail: srm_dfr@hotmail.com     FidoNET: 2:206/233
}
INTERFACE
Uses STMR_LOW,STMR_STR,STMR_FON,ASMUtils;

type
 FrameType        = String[6];

 Static_VidInfoRec = Record
  Sup_VidModes1       :Byte;
  Sup_VidModes2       :Byte;
  Sup_VidModes3       :Byte;
  RESERVED            :LongInt;
  Sup_Scanlines       :Byte;
  MaxTextCharSets     :Byte;
  TextDefsInCharRAM   :Byte;
  Capabilities1       :Byte;
  Capabilities2       :Byte;
  RESERVED2           :Word;
  SaveAreaCapabil     :Byte;
  RESERVED3           :Byte;
 end;

 Dynamic_VidInfoRec = Record
  StaticTable           :Pointer;
  VideoMode             :Byte;
  Columns               :Word;
  VideoBufSize          :Word;
  VideoBufStart         :Word;
  CursorPosTable        :Array[1..8] of Word; {col,row}
  CursorEndLine         :Byte;
  CursorStartLine       :Byte;
  ActiveVideoPage       :Byte;
  CRTC_addr_port        :Word;
  CRTC_3x8_reg          :Byte;
  CRTC_3x9_reg          :Byte;
  Disp_Char_Rows        :Byte;
  Char_Matrix_Height    :Word; { in points }
  ActiveDisplayCode     :Byte;
  InActiveDisplayCode   :Byte;
  DisplayedColors       :Word; { mono = 0 }
  Supported_VidPages    :Byte;
  ScanLines             :Byte; { 0=200, 1=350, 2=400, 3=480 }
  TextCharTable1        :Byte;
  TextCharTable2        :Byte;
  StateInfo1            :Byte;
  RESERVED              :Array[1..3] of Byte;
  VideoRAM              :Byte; { 0=64K, 1=128K, 2=192K, 3=256K }
  SaveAreaStatus        :Byte;
  RESERVED2             :LongInt;
  unknown_fixup         :Array[1..8] of Byte;
 end;

const
 NilFrame: FrameType='      ';      { frame 0 }
 SinFrame: FrameType='ĳڿ';      { frame 1 }
 DouFrame: FrameType='ͺɻȼ';      { frame 2 }
 SveFrame: FrameType='ĺַӽ';      { frame 3 }
 ShoFrame: FrameType='ͳոԾ';      { frame 4 }

 {$I C:\UTILS\BP\INCLUDE\KEYCONST }

{-[ Function Interface ]----------------------------------------------------}

Procedure ScreenStore(var Screen: Pointer);
{
 Description: Store the contents of the visible page (0).

 See also: #ScreenRestore#
}

Procedure ScreenRestore(const Screen: Pointer);
{
 Description: Retrieve the contents of a previously stored text page.

 See also: #ScreenStore#
}

Procedure WindowBox(const x,y,w,h,HiAttr,LoAttr,BackAttr: Byte;
                    const Frame: FrameType;const Shadow: Boolean);
{
  Written: 96-xx-xx, Eddy L O Jansson (2:206/233)

  Description: Draw a rectangular window on the current page. The
  *Attr parameters define the attribute for the left-upper frame,
  right-lower frame and the background respectively. #FrameType#
  is a 6 byte string of the form 'ĳڿ', used to draw the frame.
  Shadow is a boolean, specifying wheter or not a shadow is wanted
  under the window.

  Example: WindowBox(0,0,SW,SH,$7F,$78,$7F,SinFrame,False);

  Known bugs: The window/shadow will wrap if written past #SH#/#SW#.

  See also: #WindowBox2# #GrayMessageBox# #AttentionWindow#
}
Procedure WindowBox2(const X,Y,W,H,HiAttr,LoAttr,BackAttr: Byte;const Frame: FrameType;
                     const HeadOfs,HeadAttr: Byte;const Header: String;const Shadow: Boolean);
{
 Written: 96-xx-xx, Eddy L O Jansson (2:206/233)

 Description: As #WindowBox# but with a twist, the header.

 Example:

 WindowBox2(0,0,SW,SH-1,$7F,$78,$7F,SinFrame,1,$1B,' WindowBox2() ',False);

 See also: #WindowBox# #GrayMessageBox# #AttentionWindow#
}
Procedure GrayMessageBox(const S: String;const Y: Byte);

Procedure AttentionWindow(const X,Y,W,H,ATTR,BACK: Byte);

{ ** Rewrite to work with different widths!
Procedure NCButton(const nr: byte;const s: string);
Procedure NCBottomLine(const s1,s2,s3,s4,s5,s6,s7,s8,s9,s10: string);
}

Function LightBar(const X,Y,W,H,StartPos,BackAttr,BarAttr: Byte): Byte;
{
  Written: 96-12-15, Eddy L O Jansson (2:206/233)

  Description: Pretty mush self-explainatory. Try it out.

  Example: p:=LightBar(25,5,12,10,$78,$1E);
}

Procedure Get_DynamicVidInfo(var TVidInfo);
{
  Written: 97-01-19, Eddy L O Jansson (2:206/233)

  Description: Fill in/update a 'DynamicVideoInfo' record.

  See also #Dynamic_VidInfoRec# #Static_VidInfoRec#

 Example:

 Program Test_Get_DynamicVidInfo;
 VAR
  V             :Dynamic_VidInfoRec;
  S             :^Static_VidInfoRec;

 BEGIN
  Get_DynamicVidInfo(V);
  New(S);
  S:=V.StaticTable;
  WriteLn('Video Buffer Size: ',V.VideoBufSize);
  WriteLn('Supported Scanlines: ',S^.Sup_Scanlines);
 END.
}

Procedure StatusBar(X,Y,W: Byte;MaxValue,CurrValue: LongInt);

Procedure ProgressBar(const X,Y,W,Percentage: Byte);
{
 Written: 97-07-12, Eddy L O Jansson (2:206/233)

 Description:

 text-mode progress bar. Supply the X,Y,Width and %full.

 See also: #ProgressBarSmooth#
}

Procedure ProgressBarSmooth(const X,Y,W,Percentage: Byte);
{
 Written: 97-07-12, Eddy L O Jansson (2:206/233)

 Description:

 A 'smooth' text-mode progress bar. Supply the X,Y position, Width
 and the 'current state', in percent.

 This procedure will redefine ASCII 1 to create a smooth progression. A
 simpler version which lacks this feature is available as #ProgressBar#.

 See also: #ProgressBar#
}

{-[ Implementation / Code ]-------------------------------------------------}

IMPLEMENTATION

Procedure ScreenStore(var Screen: Pointer);
begin
 GetMem(Screen,PageSize);
 Move32(Mem[$B800:0000],Screen^,PageSize);
end;

Procedure ScreenRestore(const Screen: Pointer);
begin
 Move32(Screen^,Mem[$B800:0000],PageSize);
 FreeMem(Screen,PageSize);
end;

Procedure WindowBox(const x,y,w,h,HiAttr,LoAttr,BackAttr: Byte;
                    const Frame: FrameType;const Shadow: Boolean);
begin
 BoxCharAttr(x,y,w,h,Word(BackAttr SHL 8)+32);
 DrawVCharAttr(x+w-1,y+1,h-2,Word(LoAttr SHL 8)+Ord(Frame[2]));
 DrawVCharAttr(x,y+1,h-2,Word(HiAttr SHL 8)+Ord(Frame[2]));
 DrawHCharAttr(x+1,y,w-2,Word(HiAttr SHL 8)+Ord(Frame[1]));
 DrawHCharAttr(x+1,y+h-1,w-2,Word(LoAttr SHL 8)+Ord(Frame[1]));
 SetCharAttrXY(x,y,Word(HiAttr SHL 8)+Ord(Frame[3]));
 SetCharAttrXY(x,y+h-1,Word(HiAttr SHL 8)+Ord(Frame[5]));
 SetCharAttrXY(x+w-1,y,Word(LoAttr SHL 8)+Ord(Frame[4]));
 SetCharAttrXY(x+w-1,y+h-1,Word(LoAttr SHL 8)+Ord(Frame[6]));
 if Shadow then
 begin
  DrawVAttr(x+w,y+1,h,8);
  DrawHAttr(x+1,y+h,w,8);
 end;
end;

Procedure WindowBox2(const X,Y,W,H,HiAttr,LoAttr,BackAttr: Byte;const Frame: FrameType;
                     const HeadOfs,HeadAttr: Byte;const Header: String;const Shadow: Boolean);
begin
 WindowBox(X,Y,W,H,HiAttr,LoAttr,BackAttr,Frame,Shadow);
 WriteXYC(X+1+HeadOfs,Y,LoAttr,'=[');
 WriteXYC(X+4+HeadOfs,Y,HeadAttr,Header);
 WriteXYC(X+4+HeadOfs+Length(Header),Y,LoAttr,']=');
end;

Procedure GrayMessageBox(const S: String;const Y: Byte);
var
 X              :Byte;
begin
 X:=(SW div 2)-(Length(S) div 2)-1;
 if Length(S) MOD 2=1 then Dec(X);
 WindowBox(X,Y-1,Length(S)+2,3,127,120,126,SinFrame,True);
 Centre(S,Y);
end;

Procedure AttentionWindow(const X,Y,W,H,ATTR,BACK: Byte);
var
 XX,YY          :Byte;
begin
 for YY:=Y to Y+H-1 do
  begin
   DrawHCharAttr(X,YY,W,Word(ATTR SHL 8)+32);
   SetAttrXY(X+W,YY,BACK);
   if YY-Y=0 then SetCharXY(X+W,YY,220) else SetCharXY(X+W,YY,219);
  end;
  DrawHCharAttr(X+1,YY+1,W,Word(BACK SHL 8)+Ord(''));
end;

Procedure NCButton(const nr: byte;const s: string);
{ calculate width of one button. = SW div buttons-(buttons*2)
  pos = button*width_of_button+(button*2)
}
var
 loop:   byte;

begin
 SetAttrXY((nr-1)*8,SH-1,7);
 SetAttrXY((nr-1)*8+1,SH-1,7);
if nr<10 then begin
 SetCharXY((nr-1)*8,SH-1,48+nr);
 for loop:=1 to 6 do SetAttrXY((nr-1)*8+loop,SH-1,48);
 for loop:=1 to length(s) do SetCharXY((nr-1)*8+loop,SH-1,ord(s[loop]));
 end else
     begin
      SetCharXY(73,SH-1,49);
      SetCharXY(74,SH-1,48);
      for loop:=1 to 8 do SetAttrXY(74+loop,SH-1,48);
      for loop:=1 to length(s) do SetCharXY(74+loop,SH-1,ord(s[loop]));
     end;
end;

Procedure NCBottomLine(const s1,s2,s3,s4,s5,s6,s7,s8,s9,s10: string);
begin
 NCButton(1,s1); NCButton(2,s2); NCButton(3,s3); NCButton(4,s4);
 NCButton(5,s5); NCButton(6,s6); NCButton(7,s7); NCButton(8,s8);
 NCButton(9,s9); NCButton(10,s10);
end;

Function LightBar(const X,Y,W,H,StartPos,BackAttr,BarAttr: Byte): Byte;
var
 Ch             :Char;
 Done           :Boolean;
 OldPos,Pos     :Byte;
begin
 Done:=False;
 Pos:=StartPos;
 While NOT Done do
  begin
   DrawHAttr(X,Y+Pos-1,W,BarAttr);
   Ch:=ReadKey;
   if Ch=#0 then
    begin
     Ch:=ReadKey;
     OldPos:=Pos;
     if (Ch=DownKey) and (Pos<H) then Inc(Pos);
     if (Ch=UpKey) and (Pos>1) then Dec(Pos);
     if (Ch=Home) then Pos:=1;
     if (Ch=EndKey) then Pos:=H;
     if OldPos<>Pos then DrawHAttr(X,Y+OldPos-1,W,BackAttr);
    end else begin
     If (Ch=ENTER) or (Ch=ESC) then Done:=True;
    end;
  end;
 if Ch=ENTER then LightBar:=Pos else LightBar:=0;
end;

Procedure Get_DynamicVidInfo(var TVidInfo); Assembler;
asm
{ push ds}
 mov  ah,$1B
 xor  bx,bx
 les  di,TVidInfo
 int  $10
{ pop  ds}
end;

Procedure StatusBar(X,Y,W: Byte;MaxValue,CurrValue: LongInt);
var
 WW             :Byte;
begin
 WW:=Trunc((CurrValue/MaxValue*100)/(100/W));
 if WW<1 then WW:=1;
 if WW>W then WW:=W;
 DrawHChar(X,Y,WW,219);
end;


Procedure ProgressBar(const X,Y,W,Percentage: Byte);
var
 whole                  :Word;
begin
 if Percentage=0 then Exit;
 if Percentage>99 then begin WriteXY(X,Y,RepeatChar(#219,W)); Exit; end;
 whole:=Trunc(W/(100/Percentage));
 WriteXY(X,Y,RepeatChar(#219,Whole));
end;

Procedure ProgressBarSmooth(const X,Y,W,Percentage: Byte);
const
 PartData :Array[1..7] of Byte=(128,192,224,240,248,252,254);
var
 BPC                    :Byte;
 Backgroundchar         :Byte;
 whole,part             :Word;
 C                      :Pointer; { Holds redefined characted data }
begin
 if Percentage=0 then Exit;
 if Percentage>99 then begin WriteXY(X,Y,RepeatChar(#219,W)); Exit; end;
 whole:=Trunc((W*8)/(100/Percentage));
 part:=whole mod 8;
 whole:=whole div 8;

 { This part will OR the progress-meter with the background character }
 if Part<7 then
 begin
  BPC:=Font_GetCurrentBPC;
  GetMem(C,BPC);
  BackgroundChar:=GetCharXY(X+Whole,Y);
  Font_FetchChar(BackgroundChar,C^);
  asm
   push ds
   lea  si,PartData
   add  si,part
   mov  bl,byte ptr [si]
   lds  si,C
   les  di,C
   @again:
   lodsb          { get original bitmap  }
   or   al,bl     { OR with progress-bitmap }
   stosb          { store the result }
   loop @again
   pop  ds
  end;
  WaitVBL;   { You might want to [re]move this if you are loading massive }
             { amounts of data and are calling this procedure often. }
  Font_Define(1,BPC,C^); { Redefine character #1 }
  FreeMem(C,BPC);
  WriteXY(X,Y,RepeatChar(#219,Whole)+#1);
 end else WriteXY(X,Y,RepeatChar(#219,Whole));
end;

BEGIN
 { Setup/Initialization }
END.
